/*
 ============================================================================
 Name		 : ConsoleKeys.cpp
 Copyright   : Symbian Academy, 2007
 Description : Waits asynchronously for the next key press.
 ============================================================================
 */

#include "ConsoleKeys.h"

// Edit 24: Implement the NewLC()-function, pass the parameters to the
//          C++ constructor.


// Edit 25: Implement the NewL()-function by calling NewLC() and popping
//          the object from the cleanup stack again afterwards.


// Edit 26: Implement the C++ constructor.
//          Call the constructor of the base class with the EPriorityUserInput.
//          Assign the two parameters (console + engine reference) to the
//          instance variables to keep the pointer to these objects.


// Edit 27: Implement the ConstructL()-function.
//          Add the object to the active scheduler.


// Edit 28: Implement the destructor.
//          Make sure that you call the Cancel() method of the CActive base class,
//          which will ensure that all outstanding requests will be canceled when
//          the active object is destroyed.


// Edit 29: Implement the DoCancel() method.
//          The function from CConsoleBase to cancel the asynchronous operations is
//          called ReadCancel().


// Edit 30: Implement the StartL()-function.
//          First, make sure that no other request is currently active.
//          Then, issue a request to CConsoleBase to accept a character from
//          the keyboard. Pass the iStatus-variable to the call of Read().
//          After doing this, set this AO to active.


// Edit 31: Implement RunL().
//          Call the handler function of the engine and send the key code to it.
//          iEngine->KeyPressed(iConsole->KeyCode());
//          Then, immediately start the active object again as you did in 
//          StartL(): Issue the request to the console and set the AO active.
//          If you want, you can put this functionality in an extra method,
//          to prevent duplicate code.


